
from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo, getSecurityManager

try:
    from Products.LinguaPlone.public import *
except ImportError:
    from Products.Archetypes.public import *


from config import *

schema = Schema((

        ReferenceField('ECardImage',
                    languageIndependent=1,
                    relationship='is ECardImage of',
                    allowed_types=('ATECardImage'),
                    vocabulary='getECardImageListVocabulary',
                    widget=SelectionWidget(format='select'),
                   ),
        StringField('FromEMail',
                    required=1,
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),
        StringField('FromSurname',
                    required=1,
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),
        StringField('FromLastname',
                    required=1,
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),
        StringField('ToEMail',
                    required=1,
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),                 
        StringField('ToSurname',
                    required=1,
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),
        StringField('ToLastname',
                    required=1,
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),
        DateTimeField('PostDate',
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),
        TextField('Message',
                    searchable=1,
                    required=1,
                    languageIndependent=1,
                    widget=TextAreaWidget(),
                   ),
        StringField('Password',
                    required=0,
                    languageIndependent=1,
                    widget=StringWidget(),
                   ),
    ))

class ATECard(BaseContent):

    archetype_name = 'ATECard'
    content_icon   = 'atecard_icon.gif'
    typeDescription= ("ATECard Description")
    typeDescMsgId  = 'description_edit_image'
    assocMimetypes = ('image/*', )
    assocFileExt   = ('jpg', 'jpeg', 'png', 'gif', )

    schema = BaseSchema + schema

    factory_type_information = {
        'allow_discussion': 0,
        'immediate_view': 'ecard_view',
        'global_allow': 0,
        }
        
    actions = (
                { 'id': 'view',
                  'name': 'View',
                  'action': 'string:${object_url}/ecard_view',
                  'permissions': 'View',
                  'category':'object',
                  },     
               )
    
    
    def getAllowed(self, pPassword):
        vSecurityManager = getSecurityManager()
        if self.getPassword() == pPassword or (vSecurityManager.checkPermission(CMFCorePermissions.ModifyPortalContent, self) or 0):
            return True
        else:
            return False
            
    def getTitle(self):
        return self.Title()    
    
    
    def getECardImageListVocabulary(self):
        vocabulary = []
        container = self.aq_parent
        for image in container.objectValues('ATECardImage'):
            vocabulary.append((image.UID(), image.title_or_id()))

        return vocabulary
    
registerType(ATECard)
