
from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo

from datetime import datetime


try:
    from Products.LinguaPlone.OrderedBaseFolder import OrderedBaseFolder as BaseClass
    from Products.LinguaPlone.public import *
except ImportError:
    from Products.Archetypes.OrderedBaseFolder import OrderedBaseFolder as BaseClass
    from Products.Archetypes.public import *

from config import *


from ATECard import ATECard

schema = Schema((
    ))

class ATECardContainer(BaseClass):

    archetype_name = 'ATECardContainer'
    content_icon   = 'atecardcontainer_icon.gif'
    typeDescription= ("Here your ecard-images and ecard-objects are placed")
    typeDescMsgId  = 'description_edit_image'
    
    schema = BaseSchema + schema

    security = ClassSecurityInfo()

    factory_type_information = {
        'allow_discussion': 0,
        'immediate_view': 'ecard_list',
        'global_allow': 1,
        'allowed_content_types': ('ATECardContainer', 'ATECard', 'ATECardImage'), 
        'filter_content_types': 1,
        }
        
    actions = (
                { 'id': 'view',
                  'name': 'View',
                  'action': 'string:${object_url}/ecard_send',
                  'permissions': 'View',
                  'category':'object',
                  },   
                { 'id': 'list_ecards',
                  'name': 'List ECards',
                  'action': 'string:${object_url}/ecard_list',
                  'permissions': 'ModifyPortalContent',
                  'category':'object',
                  },     
               )

    def __init__(self, oid, **kwargs):
        BaseClass.__init__(self, oid, **kwargs)
        


    


    def getTitle(self):
        return self.Title()

    def getDescription(self, **kwargs):
        return self.Description(**kwargs)

    security.declarePublic('sendECard')
    def sendECard(self, pParameterDict):
        
        
        vTypeName = 'ATECard'
        
        
        vId = 'testECard' #self.generateUniqueId(type_name = vTypeName)

        
        
        vECardImage = pParameterDict.get('ECardImage', '')
        vFromSurname = pParameterDict.get('FromSurname', '')
        vFromLastname = pParameterDict.get('FromLastname', '')
        vFromEMail = pParameterDict.get('FromEMail', '')
        vToSurname = pParameterDict.get('ToSurname', '')
        vToLastname = pParameterDict.get('ToLastname', '')
        vToEMail = pParameterDict.get('ToEMail', '')
        vMessage = pParameterDict.get('Message', '')
        
        vTitle = 'ECard von %s %s' % (vFromSurname, vFromLastname)
        vPostDateString = datetime.today().strftime('%Y/%m/%d')
        vPassword = 'testPassword'
        
        
        # create ATECard-Object
        try:
            vECardObject = getattr(self, vId)
        except AttributeError:
            self.invokeFactory(vTypeName, vId)
            vECardObject = getattr(self, vId)
        vECardObject.setTitle(vTitle)
        vECardObject.setECardImage(vECardImage)
        vECardObject.setFromSurname(vFromSurname)
        vECardObject.setFromLastname(vFromLastname)
        vECardObject.setFromEMail(vFromEMail)
        vECardObject.setToSurname(vToSurname)
        vECardObject.setToLastname(vToLastname)
        vECardObject.setToEMail(vToEMail)
        vECardObject.setMessage(vMessage)
        vECardObject.setPostDate(vPostDateString)
        vECardObject.setPassword(vPassword)
        vECardObject.reindexObject()
        
        # send EMail to Recipient
        vMailBody = 'Hallo %s %s,\n' % (vToSurname, vToLastname)+\
                    '\n' +\
                    'Sie haben eine ECard von %s %s erhalten.\n' % (vFromSurname, vFromLastname) +\
                    '\n' +\
                    'Klicken Sie auf den folgenden Link, um die ECard anzusehen:\n' +\
                    '%s/ecard_view?password=%s\n' % (vECardObject.absolute_url(), vPassword) +\
                    '\n\n\n'
        try:
            vMailHost = getattr(self, 'MailHost')
            vMailHost.secureSend(str(vMailBody), str(vToEMail),
                             str(vFromEMail), subject=vTitle,
                             subtype='plain', charset='UTF-8',
                             debug=True
                            )
            vErrorMsg = None
        except Exception, e:
            vErrorMsg = str(e)
        
        
        
        # HTMLString
        vHTMLString  = '<H1>ECard wurde versendet</H1>' +\
                       '<HR>' +\
                       vMailBody.replace('\n', '<BR>') +\
                       '<HR>'
        if not vErrorMsg:
            vHTMLString += 'MAIL SUCCESS<BR>'
        else:
            vHTMLString += 'MAIL ERROR: %s<BR>' % vErrorMsg
        
        return vHTMLString
        



    def manage_afterAdd(self, item, container, **kwargs):
        BaseClass.manage_afterAdd(self, item, container, **kwargs)
        item.addContentTypeRegistry()

    def addContentTypeRegistry(self):
        ##############################################################
        ## makes it possible to add ECards by a ftp client 
        ##############################################################
        if self.aq_parent.portal_type != self.portal_type:
            vString = ''
            try:
                self.manage_addProduct[ 'CMFCore' ].manage_addRegistry()
            except:
                vString += '"content_type_registry" already exists'
            
            reg = self.content_type_registry
            
            vECardType = 'ATECardImage'
            
            if not reg.getPredicate('image_jpeg'):
               reg.addPredicate( 'image_jpeg', 'major_minor' )
               reg.getPredicate( 'image_jpeg' ).edit( major="image", minor="jpeg" )
               reg.assignTypeName( 'image_jpeg', vECardType )
               reg.reorderPredicate('image_jpeg', 0)
               vString += 'Added image/jpeg to content_type_registry on position 0.'
        
            if not reg.getPredicate('image_png'):
               reg.addPredicate( 'image_png', 'major_minor' )
               reg.getPredicate( 'image_png' ).edit( major="image", minor="png" )
               reg.assignTypeName( 'image_png', vECardType ) 
               reg.reorderPredicate('image_png', 1)
               vString += 'Added image/png to content_type_registry on position 1.'
            
            return vString
    
    
    def invokeFactory(self, type_name, id, *args, **kw):
        ################################################
        ##  is called if a FTP client adds something
        ################################################
        vECardContainerType = 'ATECardContainer'
        if type_name == self.portal_type:
            return BaseClass.invokeFactory(self, vECardContainerType, id, *args, **kw)
        else:
            return BaseClass.invokeFactory(self, type_name, id, *args, **kw)
    
    
registerType(ATECardContainer)
